org.apache.flume.sink.solr.morphline

## Class MorphlineSink

- java.lang.Object
- - org.apache.flume.sink.AbstractSink
  - - org.apache.flume.sink.solr.morphline.MorphlineSink

- All Implemented Interfaces:
    Configurable, LifecycleAware, NamedComponent, Sink
  Direct Known Subclasses:
    MorphlineSolrSink

      public class MorphlineSink
      extends AbstractSink
      implements Configurable

  Flume sink that extracts search documents from Flume events and processes them using a morphline `Command` chain.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.apache.flume.Sink

      `Sink.Status`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `BATCH_DURATION_MILLIS`
    `static String` | `BATCH_SIZE`
    `static String` | `HANDLER_CLASS`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `MorphlineSink()`
    `protected` | `MorphlineSink(MorphlineHandler handler)` For testing only

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `configure(Context context)` Request the implementing class to (re)configure itself.
    `Sink.Status` | `process()` Requests the sink to attempt to consume data from attached channel
    `void` | `start()` Starts a service or component.
    `void` | `stop()` Stops a service or component.
    `String` | `toString()`

    - ### Methods inherited from class org.apache.flume.sink.AbstractSink

      `getChannel, getLifecycleState, getName, setChannel, setName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### BATCH_SIZE

          public static final String BATCH_SIZE

      See Also:
        Constant Field Values

    - #### BATCH_DURATION_MILLIS

          public static final String BATCH_DURATION_MILLIS

      See Also:
        Constant Field Values

    - #### HANDLER_CLASS

          public static final String HANDLER_CLASS

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### MorphlineSink

          public MorphlineSink()

    - #### MorphlineSink

          protected MorphlineSink(MorphlineHandler handler)

      For testing only

  - ### Method Detail

    - #### configure

          public void configure(Context context)

      Description copied from interface: `Configurable`

      Request the implementing class to (re)configure itself.

      When configuration parameters are changed, they must be reflected by the component asap.

      There are no thread safety guarantees on when configure might be called.

      Specified by:
        `configure` in interface `Configurable`

    - #### start

          public void start()

      Description copied from interface: `LifecycleAware`

      Starts a service or component.

      Implementations should determine the result of any start logic and effect the return value of `LifecycleAware.getLifecycleState()` accordingly.

      Specified by:
        `start` in interface `LifecycleAware`
      Overrides:
        `start` in class `AbstractSink`

    - #### stop

          public void stop()

      Description copied from interface: `LifecycleAware`

      Stops a service or component.

      Implementations should determine the result of any stop logic and effect the return value of `LifecycleAware.getLifecycleState()` accordingly.

      Specified by:
        `stop` in interface `LifecycleAware`
      Overrides:
        `stop` in class `AbstractSink`

    - #### process

          public Sink.Status process()
                              throws EventDeliveryException

      Description copied from interface: `Sink`

      Requests the sink to attempt to consume data from attached channel

      Note: This method should be consuming from the channel within the bounds of a Transaction. On successful delivery, the transaction should be committed, and on failure it should be rolled back.

      Specified by:
        `process` in interface `Sink`
      Returns:
        READY if 1 or more Events were successfully delivered, BACKOFF if no data could be retrieved from the channel feeding this sink
      Throws:
        `EventDeliveryException` - In case of any kind of failure to deliver data to the next hop destination.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractSink`

Copyright © 2009-2016 Apache Software Foundation. All Rights Reserved.